### bootstrapper - персональное рабочее место разработчика 1С.

Данное приложение ставит перед собой цель - автоматизация производственной рутины разработчика 1С.

### Текущий функционал:

- Работа с исходниками конфигурации (Выгрузка\загрузка в файлы)
- Работа с исходниками расширений (Выгрузка\загрузка в файлы)
- Стат. анализ используя bsl-ls
- Работас с unit тестами vanessa-add

### Настройка

#### 1. Устанавливаем пакет 

``` opm install bootstrapper ```

#### 2. Структура проекта

Данный инструмент не накладывает каких-либо ограничений на структуру вашего проекта. Он достаточно гибко позволяет управлять структурой каталогов для хранения исходников. Для примера возьмем вот такую структуру за основу:

```
--myRepo // основной каталог проекта
----src
------add // каталог исходников юнит тестов
------cf // каталог исходников конфигурации
------cfe 
--------ext1 // каталог расширения
----build // Каталог артефактов(тут будут бинарники, результаты стат анализа, результаты тестов)
----.project.json // файл с описанием структуры проекта
----autumn-properties.json // локальные настройки проекта
```

Опишем эту структуру в файле:

```.project.json```

```json
{
    "КаталогКонфигурации": "src\\cf",
    "КаталогСборки": "build",
    "ВанессаАДД" : {
        "КаталогИсходников" : "src\\add",
        "КаталогОбработок" : "build\\add"
    },
    "Расширения": [ 
                    {
                        "Имя": "Расширение1", 
                        "Каталог": "src\\cfe\\ext1"
                    } 
                ]
}
```

Этот файл логично хранить вместе с исходниками, в репозитории в корне проекта.

#### 3. Локальные настройки

Персональные настройки также хранятся в корне проекта, в файле

```autumn-properties.json```

```json
{
    "bootstrapper": {
        "ibconnection": "/FC:\\nivanchenko\\home\\tmp\\somebase\\ib", // строка подключения к базе
        "v8version": "8.3.25", // версия платформы
        "dbuser": "Админ", // логин
        "dbpwd": "", // пароль
        "ibcmd": true, // использовать автономный сервер для сборки\разборки
        "bslls": "C:\\nivanchenko\\app\\bsl-language-server\\bsl-language-server.exe", // путь до бинарника линтера bsl-ls
        "monaco": false // просмотр замечаний bsl-ls через редактор на базе monaco
    }
}
```

Этот файл рекомендуется исключать из отслеживания в репозитории, так как предполагается, что он будет персональный, у каждого разработчика свой.

#### 4. Запуск приложения.

В корне проекта выполняем команду: 
```shell
bootstrapper gui -o -p 8080
```
Опции:  
```o``` - открыть браузер с нужной страницей  
```p``` - порт на котором запустится bootstrapper

### Функционал в разработке:

- Поддержка yaxUnit
- Работа с git
- Работа с внешними обработками и отчетами
- Поддержка vanessa-automation
- Усовершенствование (dark theme)
